//+------------------------------------------------------------------+
//|                                               SuperTrend nrp.mq4 |
//|                                                                  |
//| original Super trend for metatrader made by Jason Robinson       |
//| calculation correction, repainting solving and mtf by mladen     |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 PaleVioletRed
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

//
//
//
//
//

extern string TimeFrame      = "Current time frame";
extern int    CciPeriod      = 50;
extern int    CciPrice       = PRICE_TYPICAL;
extern int    AtrPeriod      = 5;
extern int    SmoothLength   = 5;
extern double SmoothPhase    = 0;
extern bool   SmoothDouble   = true;
extern int    NormPeriod     = 100;
extern bool   OldCalculation = false;
extern bool   Interpolate    = true;

//
//
//
//
//

double STrend[];
double STrendDoA[];
double STrendDoB[];
double cci[];
double prices[];
double atr[];
double natr[];
double trend[];
double temp[];

//
//
//
//
//

int    timeFrame;
string IndicatorFileName;
bool   ReturningBars;
bool   CalculatingStr;
double UpDownShift;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,STrend);    SetIndexLabel(0,"SuperTrend");
      SetIndexBuffer(1,STrendDoA); SetIndexLabel(1,"SuperTrend");
      SetIndexBuffer(2,STrendDoB); SetIndexLabel(2,"SuperTrend");
      SetIndexBuffer(3,cci);
      SetIndexBuffer(4,prices);
      SetIndexBuffer(5,natr);
      SetIndexBuffer(6,atr);
      SetIndexBuffer(7,trend);

      //
      //
      //
      //
      //
         
         IndicatorFileName = WindowExpertName();
         CalculatingStr    = (TimeFrame=="CalculateStr"); if (CalculatingStr) return(0);
         ReturningBars     = (TimeFrame=="returnBars");   if (ReturningBars)  return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
         //
         //
         //
         //
         //
         
         if (OldCalculation)
         {
            switch(Period())
            {
               case 1:     UpDownShift = 3;   break;
               case 5:     UpDownShift = 5;   break;
               case 15:    UpDownShift = 7;   break;
               case 30:    UpDownShift = 9;   break;
               case 60:    UpDownShift = 20;  break;
               case 240:   UpDownShift = 35;  break;
               case 1440:  UpDownShift = 40;  break;
               case 10080: UpDownShift = 100; break;
               case 43200: UpDownShift = 120; break;
            }
            UpDownShift *= Point;
            if (Digits==3 || Digits==5)
               UpDownShift *= 10.0;
         }            
         
   
      //
      //
      //
      //
      //
   
   IndicatorShortName("SuperTrend "+timeFrameToString(timeFrame));    
}
int deinit()
{
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i,r;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ReturningBars) { STrend[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (CalculatingStr || timeFrame==Period())
   {      
      if (!CalculatingStr && trend[limit]==-1) CleanPoint(limit,STrendDoA,STrendDoB);
      if (ArraySize(temp)!=Bars) ArrayResize(temp,Bars);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++) temp[r] = MathMax(High[r+i],Close[r+i+1]) - MathMin(Low[r+i],Close[r+i+1]); 
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         prices[i] = getPrice(CciPrice,i);
         atr[i]    = iDSmooth(temp[r],SmoothLength,SmoothPhase,SmoothDouble,i,0);
            double avg = iDSmooth(prices[i],CciPeriod,SmoothPhase,SmoothDouble,i,20); 
            double dev = 0; for(int k=0; k<CciPeriod; k++) dev += MathAbs(prices[i+k]-avg); dev /= CciPeriod;
               if (dev!=0)
                     cci[i] = iDSmooth((prices[i]-avg)/(0.015*dev),SmoothLength,SmoothPhase,SmoothDouble,i,40);
               else  cci[i] = iDSmooth(0,                          SmoothLength,SmoothPhase,SmoothDouble,i,40); 
               
           //
           //
           //
           //
           //
               
           double MaxAtr = atr[ArrayMaximum(atr,NormPeriod,i)];
           double MinAtr = atr[ArrayMinimum(atr,NormPeriod,i)];
              
               if (MaxAtr != MinAtr)
                   natr[i] = iDSmooth(100*(atr[i]-MinAtr)/(MaxAtr-MinAtr),SmoothLength,SmoothPhase,SmoothDouble,i,60);
              else natr[i] = iDSmooth(0,                                  SmoothLength,SmoothPhase,SmoothDouble,i,60);    
         
         //
         //
         //
         //
         //
         
         STrendDoA[i] = EMPTY_VALUE;
         STrendDoB[i] = EMPTY_VALUE;
         trend[i]     = trend[i+1];
            if (cci[i] > 0)    trend[i] =  1;
            if (cci[i] < 0)    trend[i] = -1;
            if (!OldCalculation) UpDownShift = natr[i];
            if (trend[i] ==  1) STrend[i] = MathMax(Low[i]  - UpDownShift,STrend[i+1]);
            if (trend[i] == -1) STrend[i] = MathMin(High[i] + UpDownShift,STrend[i+1]); 
            
            //
            //
            //
            //
            //
            
            if (!CalculatingStr && trend[i] == -1) PlotPoint(i,STrendDoA,STrendDoB,STrend);
      }
      return(0);
   }

   //
   //
   //
   //
   //
   
   if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (trend[limit] == -1) CleanPoint(limit,STrendDoA,STrendDoB);

   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i]     = iCustom(NULL,timeFrame,IndicatorFileName,"CalculateStr",CciPeriod,CciPrice,AtrPeriod,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,OldCalculation,7,y);
         STrend[i]    = iCustom(NULL,timeFrame,IndicatorFileName,"CalculateStr",CciPeriod,CciPrice,AtrPeriod,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,OldCalculation,0,y);
         STrendDoA[i] = EMPTY_VALUE;
         STrendDoB[i] = EMPTY_VALUE;

         //
         //
         //
         //
         //
      
         if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if (!Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            double factor = 1.0 / n;
            for(int x = 1; x < n; x++) STrend[i+x] = x*factor*STrend[i+n] + (1.0-x*factor)*STrend[i];
   }
   for (i=limit;i>=0;i--) if (trend[i] == -1) PlotPoint(i,STrendDoA,STrendDoB,STrend);
   
   //
   //
   //
   //
   //
   
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,MathMax(MathMin(type,6),1),i));
   }      
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//
//+------------------------------------------------------------------+


double wrk[][80];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}